﻿using System.Text;

namespace TestProject;

/// <summary>
/// 문자열 확장
/// </summary>
public static class StringExtension
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Public

    #region 공백 줄이기 - ReduceWhitespace(source)

    /// <summary>
    /// 공백 줄이기
    /// </summary>
    /// <param name="source">소스 문자열</param>
    /// <returns>공백 줄인 문자열</returns>
    public static string ReduceWhitespace(this string source)
    {
        StringBuilder stringBuilder = new StringBuilder();

        bool isPreviousWhitespace = false;

        for(int i = 0; i < source.Length; i++)
        {
            if(char.IsWhiteSpace(source[i]))
            {
                if(isPreviousWhitespace)
                {
                    continue;
                }

                isPreviousWhitespace = true;
            }
            else
            {
                isPreviousWhitespace = false;
            }

            stringBuilder.Append(source[i]);
        }

        return stringBuilder.ToString();
    }

    #endregion
}